' Debug Rubik's cube
dim x_positionCamera%, y_positionCamera%, z_positionCamera%
dim x_souris%, y_souris%, x%, y%, z%, i%
dim hideShowCube%(27)
dim cube%(27)
dim cubePosition%(27,6)

label rouge90, bleu90, vert90, jaune90, orange90, blanc90
label rouge180, bleu180, vert180, jaune180, orange180, blanc180
label rouge270, bleu270, vert270, jaune270, orange270, blanc270
label rouge_90, bleu_90, vert_90, jaune_90, orange_90, blanc_90
label rouge_180, bleu_180, vert_180, jaune_180, orange_180, blanc_180
label rouge_270, bleu_270, vert_270, jaune_270, orange_270, blanc_270
label orienterCube, quitter
label show_hide_cube, afficherTriede

degrees

interfaceGraphique3D()
triedre()
creerPanneauControle()
creerPanneauControle2()

end
' ------------------------------------------------------------------------------
orienterCube:
    off_mouse_down 1

    ' on quitte le sous-programme si c'est le bouton droit de la souris qui est enfonc 
    if mouse_right_down(1) = 1
        on_mouse_down 1,orienterCube
        return
    end_if

    x_souris% = mouse_x_position(1)
    y_souris% = mouse_y_position(1)

    while mouse_left_up(1) = 0
        x% = mouse_x_position(1) - x_souris% + x_positionCamera%
        y% = mouse_y_position(1) - y_souris% + y_positionCamera%

        cam_x_position cos(x%) * 10
        cam_z_position sin(x%) * 10
        cam_y_position cos(y%) * 10
        pause 20
    end_while

    ' mmorisation de la nouvelle position de la camra en x,y,z
    x_positionCamera% = mouse_x_position(1) - x_souris% + x_positionCamera%
    y_positionCamera% = mouse_y_position(1) - y_souris% + y_positionCamera%
    z_positionCamera% = mouse_y_position(1) - x_souris% + x_positionCamera%

caption 0,y_positionCamera%
    
    on_mouse_down 1,orienterCube
return
' ------------------------------------------------------------------------------
sub interfaceGraphique3D()
    dim_local i%

    ' crer la fentre principale
    width 0,width(0) - width_client(0) + 700
    height 0,height(0) - height_client(0) + 700

    ' crer la scne 3d
    scene3d 1
    width 1,700
    height 1,700
    color 1,20,20,20
    
    ' placement de la camra au lancement du programme
    x_positionCamera% = 60
    y_positionCamera% = -60
    z_positionCamera% = 120
    cam_position cos(x_positionCamera%)*10,cos(y_positionCamera%)*10,sin(z_positionCamera%)*10
    
    ' cration des 27 cubes texturs
    for i% = 1 TO 27
        3d_mesh i%
        3d_load_object i%,"cube.3ds"
        3d_load_texture i%,str$(i%)+"DebugCube.bmp"
    next i%

    ' disposition des cubes dans les diffrentes tranches
    ' avant     centre    arrire
    ' 1 2 3    10 11 12   19 20 21    
    ' 4 5 6    13 14 15   22 23 24
    ' 7 8 9    16 17 18   25 26 27

    ' tranche avant
    3d_position 1,-2,2,2
    3d_position 2,0,2,2
    3d_position 3,2,2,2
    3d_position 4,-2,0,2
    3d_position 5,0,0,2
    3d_position 6,2,0,2
    3d_position 7,-2,-2,2
    3d_position 8,0,-2,2
    3d_position 9,2,-2,2

    ' tranche centrale
    3d_position 10,-2,2,0
    3d_position 11,0,2,0
    3d_position 12,2,2,0
    3d_position 13,-2,0,0
    3d_position 14,0,0,0
    3d_position 15,2,0,0
    3d_position 16,-2,-2,0
    3d_position 17,0,-2,0
    3d_position 18,2,-2,0
    
    ' tranche arrire
    3d_position 19,-2,2,-2
    3d_position 20,0,2,-2
    3d_position 21,2,2,-2
    3d_position 22,-2,0,-2
    3d_position 23,0,0,-2
    3d_position 24,2,0,-2
    3d_position 25,-2,-2,-2
    3d_position 26,0,-2,-2
    3d_position 27,2,-2,-2

'    ' mappage initial du cube
    for i% = 1 to 27
        cube%(i%) = i%
    next i%

    on_mouse_down 1,orienterCube
end_sub
' ------------------------------------------------------------------------------
 sub triedre()
     3d_cube 501,1       :3d_color 501,255,255,255 : 3d_scale 501,12,0.1,0.1
     3d_cube 502,1       :3d_color 502,255,255,255 : 3d_scale 502,0.1,12,0.1
     3d_cube 503,1       :3d_color 503,255,255,255 : 3d_scale 503,0.1,0.1,12
     3d_cone 504,.8,.3   :3d_color 504,255,255,255 : 3d_x_position 504,6      : 3d_z_rotate 504,-90
     3d_cone 505,.8,.3   :3d_color 505,255,255,255 : 3d_y_position 505,6
     3d_cone 506,.8,.3   :3d_color 506,255,255,255 : 3d_z_position 506,6      : 3d_x_rotate 506,-90
     3d_text 507,"X"     :3d_color 507,255,255,255 : 3d_x_position 507,6.5
     3d_text 508,"Y"     :3d_color 508,255,255,255 : 3d_y_position 508,6.5
     3d_text 509,"Z"     :3d_color 509,255,255,255 : 3d_z_position 509,7.1    : 3d_y_rotate 509,90
 end_sub
' ------------------------------------------------------------------------------
sub creerPanneauControle()
    form 100
    width 100,width(100) - width_client(100) + 320
    height 100,height(100) - height_client(100) + 320
    left 100,705
    top 100,380
    caption 100,"Panneau de contrle"
    color 100,20,20,20
    on_close 100,quitter

    image 150
    
    creerBoutons()
    serigraphieBoutons()
end_sub
' ------------------------------------------------------------------------------
sub creerBoutons()
    dim_local i%, left_position%
    command_target_is 100
    
    ' modle bouton
    picture 136
    width 136,50
    height 136,50
    top 136,260
    left 136,260
    color 136,0,0,1
    2d_target_is 136
    ' bords noirs arrondis
    2d_line 8,3,42,3
    2d_line 42,4,44,4
    2d_point 44,5
    2d_line 45,6,45,8
    2d_line 46,8,46,42
    2d_line 45,42,45,44
    2d_point 44,44
    2d_line 42,45,44,45
    2d_line 8,46,42,46
    2d_line 6,45,8,45
    2d_point 5,44
    2d_line 4,42,4,44
    2d_line 3,8,3,42
    2d_line 4,6,4,8
    2d_point 5,5
    2d_line 6,4,8,4

    2d_flood 20,20,255,255,255
    2d_image_copy 150,0,0,50,50

    ' boutons rouges
    left_position% = 10
    for i% = 101 to 106
         picture i%
         width i%,50
         height i%,50
         top i%,10
         left i%,left_position%
         2d_target_is i%
         2d_image_paste 150,0,0
         2d_flood 20,20,232,40,40
         left_position% = left_position% + 50 
    next i%

    ' boutons verts
    left_position% = 10
    for i% = 107 to 112
         picture i%
         width i%,50
         height i%,50
         top i%,60
         left i%,left_position%
         2d_target_is i%
         2d_image_paste 150,0,0
         2d_flood 20,20,40,232,40
         left_position% = left_position% + 50 
    next i%

    ' boutons bleus
    left_position% = 10
    for i% = 113 to 118
         picture i%
         width i%,50
         height i%,50
         top i%,110
         left i%,left_position%
         2d_target_is i%
         2d_image_paste 150,0,0
         2d_flood 20,20,40,40,232
         left_position% = left_position% + 50 
    next i%

    ' boutons oranges
    left_position% = 10
    for i% = 119 to 124
         picture i%
         width i%,50
         height i%,50
         top i%,160
         left i%,left_position%
         2d_target_is i%
         2d_image_paste 150,0,0
         2d_flood 20,20,232,127,40
         left_position% = left_position% + 50 
    next i%

    ' boutons jaunes
    left_position% = 10
    for i% = 125 to 130
         picture i%
         width i%,50
         height i%,50
         top i%,210
         left i%,left_position%
         2d_target_is i%
         2d_image_paste 150,0,0
         2d_flood 20,20,245,245,0
         left_position% = left_position% + 50 
    next i%

    ' boutons blancs
    left_position% = 10
    for i% = 131 to 135
         picture i%
         width i%,50
         height i%,50
         top i%,260
         left i%,left_position%
         2d_target_is i%
         2d_image_paste 150,0,0
         2d_flood 20,20,255,255,255
         left_position% = left_position% + 50 
    next i%

    on_click 101,rouge_270
    on_click 102,rouge_180
    on_click 103,rouge_90
    on_click 104,rouge90
    on_click 105,rouge180
    on_click 106,rouge270
    on_click 107,vert_270
    on_click 108,vert_180
    on_click 109,vert_90
    on_click 110,vert90
    on_click 111,vert180
    on_click 112,vert270
    on_click 113,bleu_270
    on_click 114,bleu_180
    on_click 115,bleu_90
    on_click 116,bleu90
    on_click 117,bleu180
    on_click 118,bleu270
    on_click 119,orange_270
    on_click 120,orange_180
    on_click 121,orange_90
    on_click 122,orange90
    on_click 123,orange180
    on_click 124,orange270
    on_click 125,jaune_270
    on_click 126,jaune_180
    on_click 127,jaune_90
    on_click 128,jaune90
    on_click 129,jaune180
    on_click 130,jaune270
    on_click 131,blanc_270
    on_click 132,blanc_180
    on_click 133,blanc_90
    on_click 134,blanc90
    on_click 135,blanc180
    on_click 136,blanc270
    
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
sub serigraphieBoutons()
    dim_local colonne%, num_objet%

    num_objet% = 101
        for colonne% = 1 to  6
            print_target_is num_objet% 
            2d_target_is num_objet%
                2d_fill_color color_pixel_red(num_objet%,25,25),color_pixel_green(num_objet%,25,25),color_pixel_blue(num_objet%,25,25)
                font_name num_objet%,"Arial"
                font_size num_objet%,11
                print_locate 8,16
                print "-270"
            num_objet% = num_objet% + 6
        next colonne%

    num_objet% = 102
        for colonne% = 1 to  6
            print_target_is num_objet% 
            2d_target_is num_objet%
                2d_fill_color color_pixel_red(num_objet%,25,25),color_pixel_green(num_objet%,25,25),color_pixel_blue(num_objet%,25,25)
                font_name num_objet%,"Arial"
                font_size num_objet%,11
                print_locate 8,16
                print "-180"
            num_objet% = num_objet% + 6
        next colonne%

    num_objet% = 103
        for colonne% = 1 to  6
            print_target_is num_objet% 
            2d_target_is num_objet%
                2d_fill_color color_pixel_red(num_objet%,25,25),color_pixel_green(num_objet%,25,25),color_pixel_blue(num_objet%,25,25)
                font_name num_objet%,"Arial"
                font_size num_objet%,11
                print_locate 12,16
                print "-90"
            num_objet% = num_objet% + 6
        next colonne%

    num_objet% = 104
        for colonne% = 1 to  6
            print_target_is num_objet% 
            2d_target_is num_objet%
                2d_fill_color color_pixel_red(num_objet%,25,25),color_pixel_green(num_objet%,25,25),color_pixel_blue(num_objet%,25,25)
                font_name num_objet%,"Arial"
                font_size num_objet%,11
                print_locate 15,16
                print "90"
            num_objet% = num_objet% + 6
        next colonne%

    num_objet% = 105
        for colonne% = 1 to  6
            print_target_is num_objet% 
            2d_target_is num_objet%
                2d_fill_color color_pixel_red(num_objet%,25,25),color_pixel_green(num_objet%,25,25),color_pixel_blue(num_objet%,25,25)
                font_name num_objet%,"Arial"
                font_size num_objet%,11
                print_locate 11,16
                print "180"
            num_objet% = num_objet% + 6
        next colonne%

    num_objet% = 106
        for colonne% = 1 to  6
            print_target_is num_objet% 
            2d_target_is num_objet%
                2d_fill_color color_pixel_red(num_objet%,25,25),color_pixel_green(num_objet%,25,25),color_pixel_blue(num_objet%,25,25)
                font_name num_objet%,"Arial"
                font_size num_objet%,11
                print_locate 11,16
                print "270"
            num_objet% = num_objet% + 6
        next colonne%
end_sub
' ------------------------------------------------------------------------------
sub creerPanneauControle2()
    dim_local i%,j%,t%,l%,n%
    form 200
    width 200,width(200) - width_client(200) + 285
    height 200,height(200) - height_client(200) + 135
    left 200,705
    top 200,0
    caption 200,"HIDE / SHOW cubes"
    color 200,20,20,20
    on_close 200,quitter

    command_target_is 200

    t% = 10
    l% = 10
    n% = 201
    for j% = 1 to 3
        for i% = 1 to 9
            picture n%
            width n%,25
            height n%,25
            top n%,t%
            left n%,l%
            print_target_is n%
            print_locate 6,5
            print n%-200
            on_click n%,show_hide_cube
            n% = n% + 1
            l% = l% + 30
        next i%
        t% = t% + 30
        l% = 10
    next j%    
    
    check 250
    top 250,108
    left 250,25
    font_color 250,255,255,255
    font_size 250,10
    width 250,150
    caption 250,"Mindstorm's tride"
    mark_on 250
    on_click 250,afficherTriede
    
    command_target_is 0
end_sub
' ------------------------------------------------------------------------------
show_hide_cube:
    2d_target_is number_click
    if hideShowCube%(number_click - 200) = 0
        3d_hide number_click - 200
        hideShowCube%(number_click - 200) = 1
        2d_flood 1,1,127,127,127 
    else
        3d_show number_click -200
        hideShowCube%(number_click - 200) = 0
        2d_flood 1,1,255,255,255 
    end_if
return
' ------------------------------------------------------------------------------
afficherTriede:
    if checked(250)=1
        for i% = 501 to 509
            3d_show i%
        next i%     
    else
        for i% = 501 to 509
            3d_hide i%
        next i%     
    end_if        
return
' ------------------------------------------------------------------------------
rouge90:
    inactive 0 : inactive 100
    rotationFaceRouge(-90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
bleu90:
    inactive 0 : inactive 100
    rotationFaceBleue(-90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
vert90:
    inactive 0 : inactive 100
    rotationFaceVerte(90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
jaune90:
    inactive 0 : inactive 100
    rotationFaceJaune(90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
orange90:
    inactive 0 : inactive 100
    rotationFaceOrange(90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
blanc90:
    inactive 0 : inactive 100
    rotationFaceBlanche(-90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
rouge180:
    inactive 0 : inactive 100
    rotationFaceRouge(-180)
    active 0 : active 100            
return
' ------------------------------------------------------------------------------
bleu180:
    inactive 0 : inactive 100
    rotationFaceBleue(-180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
vert180:
    inactive 0 : inactive 100
    rotationFaceVerte(180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
jaune180:
    inactive 0 : inactive 100
    rotationFaceJaune(180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
orange180:
    inactive 0 : inactive 100
    rotationFaceOrange(180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
blanc180:
    inactive 0 : inactive 100
    rotationFaceBlanche(-180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
rouge270:
    inactive 0 : inactive 100
    rotationFaceRouge(-270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
bleu270:
    inactive 0 : inactive 100
    rotationFaceBleue(-270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
vert270:
    inactive 0 : inactive 100
    rotationFaceVerte(270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
jaune270:
    inactive 0 : inactive 100
    rotationFaceJaune(270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
orange270: 
    inactive 0 : inactive 100
    rotationFaceOrange(270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
blanc270:
    inactive 0 : inactive 100
    rotationFaceBlanche(-270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
rouge_90:
    inactive 0 : inactive 100
    rotationFaceRouge(90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
bleu_90:
    inactive 0 : inactive 100
    rotationFaceBleue(90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
vert_90:
    inactive 0 : inactive 100
    rotationFaceVerte(-90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
jaune_90: 
    inactive 0 : inactive 100
    rotationFaceJaune(-90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
orange_90: 
    inactive 0 : inactive 100
    rotationFaceOrange(-90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
blanc_90:
    inactive 0 : inactive 100
    rotationFaceBlanche(90)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
rouge_180:
    inactive 0 : inactive 100
    rotationFaceRouge(180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
bleu_180:
    inactive 0 : inactive 100
    rotationFaceBleue(180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
vert_180:
    inactive 0 : inactive 100
    rotationFaceVerte(-180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
jaune_180:
    inactive 0 : inactive 100
    rotationFaceJaune(-180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
orange_180: 
    inactive 0 : inactive 100
    rotationFaceOrange(-180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
blanc_180:
    inactive 0 : inactive 100
    rotationFaceBlanche(180)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
rouge_270:
    inactive 0 : inactive 100
    rotationFaceRouge(270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
bleu_270:
    inactive 0 : inactive 100
    rotationFaceBleue(270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
vert_270:
    inactive 0 : inactive 100
    rotationFaceVerte(-270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
jaune_270:
    inactive 0 : inactive 100
    rotationFaceJaune(-270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
orange_270:
    inactive 0 : inactive 100
    rotationFaceOrange(-270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
blanc_270:
    inactive 0 : inactive 100
    rotationFaceBlanche(270)
    active 0 : active 100
return
' ------------------------------------------------------------------------------
sub rotationFaceRouge(r%)
    dim_local angleDepart%, angleStop%, sensRotation%, i%
    ' Le centre de la face est ROUGE

    ' on dtermine les sens de rotation
    if r% < 0
        sensRotation% = -1
    else
        sensRotation% = 1
    end_if

    ' on chane tous les cubes de la tranche rouge au cube central
    3d_chain cube%(1),14
    3d_chain cube%(4),14
    3d_chain cube%(7),14
    3d_chain cube%(10),14
    3d_chain cube%(13),14
    3d_chain cube%(16),14
    3d_chain cube%(19),14
    3d_chain cube%(22),14
    3d_chain cube%(25),14
     
    ' calcul de l'angle de dpart et d'arrive
    angleDepart% = o3d_x_rotate(14) :' cube central
    angleStop% = angleDepart% + r%
        
    for r% = angleDepart% to angleStop% step sensRotation%
        3d_x_rotate 14,r% :' cube central
        pause 5
    next r%

    ' nouveau mappage du cube
    ' ....

    ' on rompt le chanage
    3d_chain_break cube%(1),14
    3d_chain_break cube%(4),14
    3d_chain_break cube%(7),14
    3d_chain_break cube%(10),14
    3d_chain_break cube%(13),14
    3d_chain_break cube%(16),14
    3d_chain_break cube%(19),14
    3d_chain_break cube%(22),14
    3d_chain_break cube%(25),14

    ' affectation nouvelles positions des cubes
    ' ..... 

end_sub
' ------------------------------------------------------------------------------
sub rotationFaceBleue(r%)
    dim_local angleDepart%, angleStop%, sensRotation%
    ' Le centre de la face est BLEU

    ' on dtermine les sens de rotation
    if r% < 0
        sensRotation% = -1
    else
        sensRotation% = 1
    end_if
     
    ' on chane tous les cubes de la tranche BLEUE au cube central
    3d_chain cube%(1),14
    3d_chain cube%(2),14
    3d_chain cube%(3),14
    3d_chain cube%(4),14
    3d_chain cube%(5),14
    3d_chain cube%(6),14
    3d_chain cube%(7),14
    3d_chain cube%(8),14
    3d_chain cube%(9),14

    angleDepart% = o3d_z_rotate(14)
    angleStop% = angleDepart% + r%
        
    for r% = angleDepart% to angleStop% step sensRotation%
        3d_z_rotate 14,r% :' cube central
        pause 5
    next r%

    ' on rompt le chanage
    3d_chain_break cube%(1),14
    3d_chain_break cube%(2),14
    3d_chain_break cube%(3),14
    3d_chain_break cube%(4),14
    3d_chain_break cube%(5),14
    3d_chain_break cube%(6),14
    3d_chain_break cube%(7),14
    3d_chain_break cube%(8),14
    3d_chain_break cube%(9),14

end_sub
' ------------------------------------------------------------------------------
sub rotationFaceOrange(r%)
    dim_local angleDepart%, angleStop%, sensRotation%
    ' Le centre de la face est ORANGE

    ' on dtermine les sens de rotation
    if r% < 0
        sensRotation% = -1
    else
        sensRotation% = 1
    end_if
     
    ' on chane tous les cubes de la tranche ORANGE au cube central
    3d_chain cube%(3),14
    3d_chain cube%(6),14
    3d_chain cube%(9),14
    3d_chain cube%(12),14
    3d_chain cube%(15),14
    3d_chain cube%(18),14
    3d_chain cube%(21),14
    3d_chain cube%(24),14
    3d_chain cube%(27),14

    angleDepart% = o3d_x_rotate(14)
    angleStop% = angleDepart% + r%
        
    for r% = angleDepart% to angleStop% step sensRotation%
        3d_x_rotate 14,r% :' centre orange
        pause 5
    next r%

    ' on rompt le chanage
    3d_chain_break cube%(3),14
    3d_chain_break cube%(6),14
    3d_chain_break cube%(9),14
    3d_chain_break cube%(12),14
    3d_chain_break cube%(15),14
    3d_chain_break cube%(18),14
    3d_chain_break cube%(21),14
    3d_chain_break cube%(24),14
    3d_chain_break cube%(27),14

end_sub
' ------------------------------------------------------------------------------
sub rotationFaceVerte(r%)
    dim_local angleDepart%, angleStop%, sensRotation%
    ' Le centre de la face est VERT

    ' on dtermine les sens de rotation
    if r% < 0
        sensRotation% = -1
    else
        sensRotation% = 1
    end_if
     
    ' on chane tous les cubes de la tranche VERTE au cube central
    3d_chain cube%(19),14
    3d_chain cube%(20),14
    3d_chain cube%(21),14
    3d_chain cube%(22),14
    3d_chain cube%(23),14
    3d_chain cube%(24),14
    3d_chain cube%(25),14
    3d_chain cube%(26),14
    3d_chain cube%(27),14

    angleDepart% = o3d_z_rotate(14)
    angleStop% = angleDepart% + r%
        
    for r% = angleDepart% to angleStop% step sensRotation%
        3d_z_rotate 14,r% :' centre vert
         pause 5
    next r%

    ' on rompt le chanage
    3d_chain_break cube%(19),14
    3d_chain_break cube%(20),14
    3d_chain_break cube%(21),14
    3d_chain_break cube%(22),14
    3d_chain_break cube%(23),14
    3d_chain_break cube%(24),14
    3d_chain_break cube%(25),14
    3d_chain_break cube%(26),14
    3d_chain_break cube%(27),14

end_sub
' ------------------------------------------------------------------------------
sub rotationFaceBlanche(r%)
    dim_local angleDepart%, angleStop%, sensRotation%
    ' Le centre de la face est BLANC

    ' on dtermine les sens de rotation
    if r% < 0
        sensRotation% = -1
    else
        sensRotation% = 1
    end_if
     
    ' on chane tous les cubes de la tranche BLANCHE au cube central
    3d_chain cube%(1),14
    3d_chain cube%(2),14
    3d_chain cube%(3),14
    3d_chain cube%(10),14
    3d_chain cube%(11),14
    3d_chain cube%(12),14
    3d_chain cube%(19),14
    3d_chain cube%(20),14
    3d_chain cube%(21),14

    angleDepart% = o3d_y_rotate(14)
    angleStop% = angleDepart% + r%
        
    for r% = angleDepart% to angleStop% step sensRotation%
        3d_y_rotate 14,r% :' centre blanc
        pause 5
    next r%

    ' on rompt le chanage
    3d_chain_break cube%(1),14
    3d_chain_break cube%(2),14
    3d_chain_break cube%(3),14
    3d_chain_break cube%(10),14
    3d_chain_break cube%(11),14
    3d_chain_break cube%(12),14
    3d_chain_break cube%(19),14
    3d_chain_break cube%(20),14
    3d_chain_break cube%(21),14

end_sub
' ------------------------------------------------------------------------------
sub rotationFaceJaune(r%)
    dim_local angleDepart%, angleStop%, sensRotation%
    ' Le centre de la face est JAUNE

    ' on dtermine les sens de rotation
    if r% < 0
        sensRotation% = -1
    else
        sensRotation% = 1
    end_if
     
    ' on chane tous les cubes de la tranche JAUNE au cube central
    3d_chain cube%(7),14
    3d_chain cube%(8),14
    3d_chain cube%(9),14
    3d_chain cube%(16),14
    3d_chain cube%(17),14
    3d_chain cube%(18),14
    3d_chain cube%(25),14
    3d_chain cube%(26),14
    3d_chain cube%(27),14

    angleDepart% = o3d_y_rotate(14)
    angleStop% = angleDepart% + r%
        
    for r% = angleDepart% to angleStop% step sensRotation%
        3d_y_rotate 14,r% :' centre jaune
        pause 5
    next r%

    ' on rompt le chanage
    3d_chain_break cube%(7),14
    3d_chain_break cube%(8),14
    3d_chain_break cube%(9),14
    3d_chain_break cube%(16),14
    3d_chain_break cube%(17),14
    3d_chain_break cube%(18),14
    3d_chain_break cube%(25),14
    3d_chain_break cube%(26),14
    3d_chain_break cube%(27),14

end_sub

' ------------------------------------------------------------------------------
quitter:
    terminate
return
